/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
 package cours
{
	import starling.utils.deg2rad;
	import flash.display.Bitmap;
	import starling.display.Image;
	import starling.textures.Texture;

	import starling.display.Sprite;
	import starling.events.Event;

	/**
	 * Utilisation du Framework 2D Starling.
	 * 
	 */
	public class Game extends Sprite
	{
		
		private var container:Sprite; 
 
		private static const NUM_LOGO : uint = 63;
		
		[Embed(source = "../bin/logo-as3.jpg")]
		private static const LogoAS3 : Class;


		public function Game()
		{
			// attend la fin de l'initialisation de la scène
			addEventListener(Event.ADDED_TO_STAGE, onAdded);
		}

		private function onAdded(e : Event) : void
		{
			// création du container
			container = new Sprite();

			// met à jour l'origine 0,0
			container.pivotX = stage.stageWidth >> 1;
			container.pivotY = stage.stageHeight >> 1;

			container.x = stage.stageWidth >> 1;
			container.y = stage.stageHeight >> 1;

			// création d'un bitmap à partir d'une image
			var logoTexture : Bitmap = new LogoAS3();

			// création d'un objet Texture avec l'image
			var texture : Texture = Texture.fromBitmap(logoTexture);

			// mise en page des logos
			for ( var i : uint = 0; i < NUM_LOGO; i++)
			{
				// création d'un nouveau logo avec la texture
				var iLogo : Image = new Image(texture);
				
				iLogo.x = Math.random() * stage.stageWidth;// position aléatoire
				iLogo.y = Math.random() * stage.stageHeight;// position aléatoire
				iLogo.rotation = deg2rad(Math.random() * 360);// rotation aléatoire
				
				container.addChild(iLogo);// ajout sur le container du logo
			}

			// affiche les logos sur la scène
			addChild(container);
			
			// pour réduire au minimum le nombre de recalcul du rendu
			container.flatten(); 

			// écouteur sur chaque image par seconde
			stage.addEventListener(Event.ENTER_FRAME, onFrame);
		}
		
		
		/**
		 * Mise à jour toutes les images.
		 * 
		 */
		private function onFrame(e : Event) : void
		{
			// rotation du container
			container.rotation += .2;
		} 

	
	}
}